/**
*	
* 运行前：请先填写Appid、APIKey以及图片的路径
*
* 色情内容过滤WebAPI 接口调用示例 接口文档（必看）：https://www.xfyun.cn/doc/content/pornContentFilterRecg/API.html
* (Very Important)创建完webapi应用添加色情内容过滤识别之后一定要设置ip白名单，找到控制台--我的应用--设置ip白名单，
* 如何设置参考：http://bbs.xfyun.cn/forum.php?mod=viewthread&tid=41891
* 共三种传图片方式，file,image_url,image_id必须选择其中的一个，
* 采用抓取网络图片方式时选取此参数,支持的文件类型包括：静态图片或图片压缩包(jpg, jpeg, bmp, png大小不超过10M，zip大小不超过50M)，url数组(数量不超过20)
* image_id时选取此参数，可在多个接口间共享，减少图片传输的带宽，支持的类型包括：image_id字符串或字符串数组(数量不超过20)
* 将图片二进制数据写入到HttpQuest body中，则不需要上传参数，否则需要上传image_url或image_id参数，body为空即可。
* 本示例采用将图片二进制数据写入到body中的方式
* 错误码链接：https://www.xfyun.cn/document/error-code (code返回错误码时必看)
 */

const CryptoJS = require('crypto-js')
var request = require('request')
var log = require('log4node')
var fs = require('fs')

// 系统配置
const config = {
  hostUrl: "https://api.xfyun.cn/v1/service/v1/image_identify/sexy_filter",
  // 色情内容过滤接口地址
  host: "api.xfyun.cn",
  //在控制台-我的应用-色情内容过滤获取
  appid: "********",
  // 接口密钥（webapi类型应用开通色情内容过滤服务后，控制台--我的应用---色情内容过滤---相应服务的apikey)
  apiKey: "********************************",
  // 本地上传图片
  file: "./demo.jpg",
  // url上传图片
  remoteFile: "http://xfyun-doc.ufile.ucloud.com.cn/1532066413309446/demo.jpg"
}

// 获取当前时间戳
let ts = parseInt(new Date().getTime() / 1000)

// 本地图片
let optionsLocal = {
  url: config.hostUrl,
  headers: getReqHeader({}),
  form: getPostBody()
}
request.post(optionsLocal, (err, resp, body) => {
  if (err) {
    log.error(err)
  }
  let res = JSON.parse(body)
  if (res.code != 0) {
    log.error(`发生错误，错误码：${res.code} 错误原因：${res.desc} sid：${res.sid}`)
    log.error(`请前往https://www.xfyun.cn/document/error-code?code=${res.code}查询解决办法`)
    return
  }
  log.info(`sid：${res.sid}`)
  log.info('【色情内容过滤 - 本地图片识别】' + JSON.stringify(res.data))
})

// 网络图片
let optionsRemote = {
  url: config.hostUrl,
  headers: getReqHeader({
    image_url: [ config.remoteFile ]
  })
}
request.post(optionsRemote, (err, resp, body) => {
  if (err) {
    log.error(err)
  }
  let res = JSON.parse(body)
  if (res.code != 0) {
    log.error(`发生错误，错误码：${res.code} 错误原因：${res.desc} sid：${res.sid}`)
    log.error(`请前往https://www.xfyun.cn/document/error-code?code=${res.code}查询解决办法`)
    return
  }
  log.info(`sid：${res.sid}`)
  log.info('【色情内容过滤 - 网络图片识别】' + JSON.stringify(res.data))
})

// 组装业务参数
function getXParamStr(xParam) {
  return CryptoJS.enc.Base64.stringify(CryptoJS.enc.Utf8.parse(JSON.stringify(xParam)))
}

// 组装请求头
function getReqHeader(xParam) {
  let xParamStr = getXParamStr(xParam)
  let xCheckSum = CryptoJS.MD5(config.apiKey + ts + xParamStr).toString()
  return {
    'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8',
    'X-Appid': config.appid,
    'X-CurTime': ts + "",
    'X-Param': xParamStr,
    'X-CheckSum': xCheckSum
  }
}

// 组装postBody
function getPostBody() {
  let buffer = fs.readFileSync(config.file)
  return {
    file	: buffer.toString('base64'),
  }
}